var bonjourSocket = Titanium.Network.createTCPSocket({
    hostName:"INADDR_ANY",
    port:40401,
    mode:Titanium.Network.READ_WRITE_MODE
});
// Searcher for finding other services
var serviceBrowser = Titanium.Network.createBonjourBrowser({
    serviceType:'_utest._tcp',
    domain:'local.'
});
var localService = Titanium.Network.createBonjourService({
    name:'Bonjour: ' + Titanium.Platform.id,
    type:'_utest._tcp',
    domain:'local.'
});

bonjourSocket.addEventListener('read', function(e) {
    var remoteSocket = e['from'];
    var dataStr = e['data'].text;
    Ti.API.debug("bonjourSocket.read() -> " + dataStr);

    if (dataStr && dataStr.startsWith('req')) {

        Ti.App.fireEvent('recieve', {text: "Request from " + dataStr});

        bonjourSocket.write('Hello, from ' + Titanium.Platform.id, remoteSocket);
    }
    else {
        Titanium.UI.createAlertDialog({
            title:'Unknown listener message...',
            message:dataStr
        }).show();
    }
});

function start() {
    if (!bonjourSocket.isValid) {
        Ti.API.debug("bonjourSocket.listen();");
        bonjourSocket.listen();

        try
        {
            Ti.API.debug("localService.publish();");
            localService.publish(bonjourSocket);
            Ti.API.debug("localService.published");
        }
        catch (e) {
            bonjourSocket.close();
            Titanium.UI.createAlertDialog({
                title:'Error!',
                message:e
            }).show();
        }

    }
}


function stop() {
    Titanium.API.info('Stopping the bonjour service...');
    localService.stop();
    Titanium.API.info('The bonjour service has stopped.');
    if (bonjourSocket.isValid) {
        Titanium.API.info('close bonjourSocket...');
        bonjourSocket.close();
        Titanium.API.info('bonjourSocket has closed.');
    }
};

function startSearch() {
    serviceBrowser.search();
}
function stopSearch() {
    serviceBrowser.stopSearch();
}

serviceBrowser.addEventListener("updatedservices", function(e) {
    var ep = {
        method: "updatedservices",
        eventParam: e
    }
    worker.postMessage(ep);
});

worker.addEventListener('message', function(event) {
    Ti.API.debug("-> fire message " + event.data.method);
    if (event && event.data) {
        var method = event.data.method;

        if (method == "start") {
            start();
        }
        else if (method == "stop") {
            stop();
        }
        else if (method == "startSearch") {
            startSearch();
        }
        else if (method == "stopSearch") {
            stopSearch();
        }
    }
});

worker.addEventListener('terminated', function(){
    terminated = true;
    Ti.API.debug("-> fire terminated");
    worker.nextTick(stop);
    worker.nextTick(stopSearch);
});
