function bonjourService(_args) {
    var worker = require('ti.worker');
    var thread = worker.createWorker('bonjourServiceOnThread.js');

    var eventMethod = null;

    this.start = function() {
        var p = {
            method: "start"
        };
        thread.postMessage(p);
    };


    this.stop = function() {
        var p = {
            method: "stop"
        };
        thread.postMessage(p);
    };

    this.startSearch = function() {
        var p = {
            method: "startSearch"
        };
        thread.postMessage(p);
    }
    this.stopSearch = function() {
        var p = {
            method: "stopSearch"
        };
        thread.postMessage(p);
    }

    if (_args && _args.updatedEvent) {
        eventMethod = _args.updatedEvent;
    }

    this.eventHandler = function(event) {
        if (event && event.data) {
            var method = event.data.method;
            if (method == "updatedservices") {
                eventMethod(event.data.eventParam);
            }
        }
    };

    thread.addEventListener('message', this.eventHandler);
    return this;
};

module.exports = bonjourService;